//+------------------------------------------------------------------+
//|                                                  MA_Trend_v2.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//| Need custom indicator/ea ? Write me an email !!!                 |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_separate_window
#property indicator_maximum 110
#property indicator_minimum -110

#property indicator_level1 0
#property indicator_level2 50
#property indicator_level3 -50
#property indicator_color1 Green
#property indicator_buffers 1

double trend[];
extern int MAnumber = 100;
extern int MAstep = 10;
extern int MAtype = MODE_EMA;
extern int Price = PRICE_CLOSE;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,trend);
   SetIndexStyle(0,DRAW_LINE);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----
   for(int i=limit;i>=0;i--)
   {
      double ttrend = 0;
      for(int m=MAnumber;m>0;m--)
      {
         double ma = iMA(Symbol(),0,m*MAstep,0,MAtype,Price,i);
         
         if(Low[i] > ma)
         ttrend+=1;
         else if (High[i] < ma)
         ttrend-=1;   
      }
      
      trend[i] = (ttrend/MAnumber)*100;
   }   
//----
   return(0);
  }
//+------------------------------------------------------------------+